speckley::WaveAssembler3D Class Reference

`#include <WaveAssembler3D.h>`

Inheritance diagram for speckley::WaveAssembler3D:

## Public Member Functions

| WaveAssembler3D (escript::const_Domain_ptr dom, const double *dx, const dim_t *NE, const dim_t *NN, const DataMap &c)
| ~WaveAssembler3D ()
virtual void | assemblePDESingle (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &A, const escript::Data &B, const escript::Data &C, const escript::Data &D, const escript::Data &X, const escript::Data &Y) const
virtual void | assemblePDEBoundarySingle (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &d, const escript::Data &y) const
virtual void | assemblePDESingleReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &A, const escript::Data &B, const escript::Data &C, const escript::Data &D, const escript::Data &X, const escript::Data &Y) const
virtual void | assemblePDEBoundarySingleReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &d, const escript::Data &y) const
virtual void | assemblePDESystem (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &A, const escript::Data &B, const escript::Data &C, const escript::Data &D, const escript::Data &X, const escript::Data &Y) const
virtual void | assemblePDEBoundarySystem (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &d, const escript::Data &y) const
virtual void | assemblePDESystemReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &A, const escript::Data &B, const escript::Data &C, const escript::Data &D, const escript::Data &X, const escript::Data &Y) const
virtual void | assemblePDEBoundarySystemReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const escript::Data &d, const escript::Data &y) const
virtual void | assemblePDESingle (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDEBoundarySingle (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDESingleReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDEBoundarySingleReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDESystem (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDEBoundarySystem (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDESystemReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
virtual void | assemblePDEBoundarySystemReduced (escript::AbstractSystemMatrix *mat, escript::Data &rhs, const DataMap &coefs) const
void | collateFunctionSpaceTypes (std::vector< int > &fsTypes, const DataMap &coefs) const
Public Member Functions inherited from speckley::AbstractAssembler
virtual | ~AbstractAssembler ()

## Protected Member Functions

| POINTER_WRAPPER_CLASS (const Brick) domain

## Protected Attributes

const double * | m_dx
const dim_t * | m_NE
const dim_t * | m_NN
bool | isHTI
bool | isVTI
escript::Data | c11
escript::Data | c12
escript::Data | c13
escript::Data | c23
escript::Data | c33
escript::Data | c44
escript::Data | c66

## Constructor & Destructor Documentation

## WaveAssembler3D()

speckley::WaveAssembler3D::WaveAssembler3D | ( | escript::const_Domain_ptr | dom,
|  | const double * | dx,
|  | const dim_t * | NE,
|  | const dim_t * | NN,
|  | const DataMap & | c
| ) |  |

inline

## ~WaveAssembler3D()

speckley::WaveAssembler3D::~WaveAssembler3D | ( |  | ) |

inline

## Member Function Documentation

## assemblePDEBoundarySingle() [1/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySingle | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDEBoundarySingle(), and speckley::unpackData().

## assemblePDEBoundarySingle() [2/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySingle | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | d,
|  | const escript::Data & | y
| ) |  | const

virtual

assembles boundary conditions of a single PDE into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDEBoundarySingle().

## assemblePDEBoundarySingleReduced() [1/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySingleReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDEBoundarySingleReduced(), and speckley::unpackData().

## assemblePDEBoundarySingleReduced() [2/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySingleReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | d,
|  | const escript::Data & | y
| ) |  | const

virtual

assembles boundary conditions of a single PDE with reduced order into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDEBoundarySingleReduced().

## assemblePDEBoundarySystem() [1/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySystem | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDEBoundarySystem(), and speckley::unpackData().

## assemblePDEBoundarySystem() [2/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySystem | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | d,
|  | const escript::Data & | y
| ) |  | const

virtual

assembles boundary conditions of a system of PDEs into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDEBoundarySystem().

## assemblePDEBoundarySystemReduced() [1/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySystemReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDEBoundarySystemReduced(), and speckley::unpackData().

## assemblePDEBoundarySystemReduced() [2/2]

void speckley::WaveAssembler3D::assemblePDEBoundarySystemReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | d,
|  | const escript::Data & | y
| ) |  | const

virtual

assembles boundary conditions of a system of PDEs with reduced order into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDEBoundarySystemReduced().

## assemblePDESingle() [1/2]

void speckley::WaveAssembler3D::assemblePDESingle | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDESingle(), and speckley::unpackData().

## assemblePDESingle() [2/2]

void speckley::WaveAssembler3D::assemblePDESingle | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | A,
|  | const escript::Data & | B,
|  | const escript::Data & | C,
|  | const escript::Data & | D,
|  | const escript::Data & | X,
|  | const escript::Data & | Y
| ) |  | const

virtual

assembles a single PDE into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDESingle().

## assemblePDESingleReduced() [1/2]

void speckley::WaveAssembler3D::assemblePDESingleReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDESingleReduced(), and speckley::unpackData().

## assemblePDESingleReduced() [2/2]

void speckley::WaveAssembler3D::assemblePDESingleReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | A,
|  | const escript::Data & | B,
|  | const escript::Data & | C,
|  | const escript::Data & | D,
|  | const escript::Data & | X,
|  | const escript::Data & | Y
| ) |  | const

virtual

assembles a single PDE with reduced order into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDESingleReduced().

## assemblePDESystem() [1/2]

void speckley::WaveAssembler3D::assemblePDESystem | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDESystem(), and speckley::unpackData().

## assemblePDESystem() [2/2]

void speckley::WaveAssembler3D::assemblePDESystem | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | A,
|  | const escript::Data & | B,
|  | const escript::Data & | C,
|  | const escript::Data & | D,
|  | const escript::Data & | X,
|  | const escript::Data & | Y
| ) |  | const

virtual

assembles a system of PDEs into the system matrix 'mat' and the right hand side 'rhs'

References escript::Data::actsExpanded(), all_lagrange_derivs, all_weights, c11, c12, c13, c23, c33, c44, c66, escript::AbstractSystemMatrix::getColumnBlockSize(), escript::Data::getDataPointSize(), escript::Data::getSampleDataRO(), escript::Data::getSampleDataRW(), INDEX3, INDEX4, escript::Data::isEmpty(), isHTI, m_dx, m_NE, m_NN, escript::Data::requireWrite(), and SI.

Referenced by assemblePDESystem().

## assemblePDESystemReduced() [1/2]

void speckley::WaveAssembler3D::assemblePDESystemReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References assemblePDESystemReduced(), and speckley::unpackData().

## assemblePDESystemReduced() [2/2]

void speckley::WaveAssembler3D::assemblePDESystemReduced | ( | escript::AbstractSystemMatrix * | mat,
|  | escript::Data & | rhs,
|  | const escript::Data & | A,
|  | const escript::Data & | B,
|  | const escript::Data & | C,
|  | const escript::Data & | D,
|  | const escript::Data & | X,
|  | const escript::Data & | Y
| ) |  | const

virtual

assembles a system of PDEs with reduced order into the system matrix 'mat' and the right hand side 'rhs'

Referenced by assemblePDESystemReduced().

## collateFunctionSpaceTypes()

void speckley::WaveAssembler3D::collateFunctionSpaceTypes | ( | std::vector< int > & | fsTypes,
|  | const DataMap & | coefs
| ) |  | const

virtual

Implements speckley::AbstractAssembler.

References speckley::isNotEmpty().

## POINTER_WRAPPER_CLASS()

speckley::WaveAssembler3D::POINTER_WRAPPER_CLASS | ( | const | Brick | ) |

protected

## Member Data Documentation

## c11

escript::Data speckley::WaveAssembler3D::c11

protected

Referenced by assemblePDESystem().

## c12

escript::Data speckley::WaveAssembler3D::c12

protected

Referenced by assemblePDESystem().

## c13

escript::Data speckley::WaveAssembler3D::c13

protected

Referenced by assemblePDESystem().

## c23

escript::Data speckley::WaveAssembler3D::c23

protected

Referenced by assemblePDESystem().

## c33

escript::Data speckley::WaveAssembler3D::c33

protected

Referenced by assemblePDESystem().

## c44

escript::Data speckley::WaveAssembler3D::c44

protected

Referenced by assemblePDESystem().

## c66

escript::Data speckley::WaveAssembler3D::c66

protected

Referenced by assemblePDESystem().

## isHTI

bool speckley::WaveAssembler3D::isHTI

protected

Referenced by assemblePDESystem().

## isVTI

bool speckley::WaveAssembler3D::isVTI

protected

## m_dx

const double* speckley::WaveAssembler3D::m_dx

protected

Referenced by assemblePDESystem().

## m_NE

const dim_t* speckley::WaveAssembler3D::m_NE

protected

Referenced by assemblePDESystem().

## m_NN

const dim_t* speckley::WaveAssembler3D::m_NN

protected

Referenced by assemblePDESystem().

The documentation for this class was generated from the following files:

- speckley/src/WaveAssembler3D.h
- speckley/src/WaveAssembler3D.cpp